package com.wd.workoffice.ui.fg;

import android.os.Bundle;
import android.text.TextUtils;

import com.scwang.smartrefresh.layout.SmartRefreshLayout;
import com.wd.workoffice.R;
import com.wd.workoffice.app.WorkBaseFg;
import com.wd.workoffice.bean.ProductBean;
import com.wd.workoffice.bean.StockBean;
import com.wd.workoffice.bean.listener.ProFilterClickListener;
import com.wd.workoffice.contract.WorkProContract;
import com.wd.workoffice.presenter.WorkProPresenter;
import com.wd.workoffice.ui.adapter.WorkProductAdapter;
import com.wd.workoffice.util.ProFilterData;
import com.wd.workoffice.util.WorkUtils;
import com.wd.workoffice.widget.DropDownMenu;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;


/**
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class WorkProFragment extends WorkBaseFg implements WorkProContract.View {

    @BindView(R.id.ddm_choose)
    DropDownMenu ddmChoose;
    private String ofKind;
    private RecyclerView rvData;
    private int page = 1;
    private Map<String, Object> param;
    private SmartRefreshLayout srlRefresh;
    private WorkProPresenter workProPresenter;
    private WorkProductAdapter workProductAdapter;
    private List<ProductBean.RecordsBean> dataList;

    @Override
    protected void initView() {
        ButterKnife.bind(this, getContentView());
        workProPresenter = new WorkProPresenter();
        workProPresenter.onAttach(this);
        ProFilterData filterData = new ProFilterData(ddmChoose, new ProFilterClickListener() {
            @Override
            public void clickStatus(String value) {
                if (TextUtils.equals(value, "全部状态")) {
                    param.put("status", "");
                } else if (TextUtils.equals(value, "正常")) {
                    param.put("status", "1");
                } else {
                    param.put("status", "0");
                }
                page = 1;
                param.put("current", page);
                workProPresenter.getPro(param);
            }

            @Override
            public void clickProcess(String value) {
                if (TextUtils.equals(value, "全部状态")) {
                    param.put("status", "");
                } else if (TextUtils.equals(value, "正常")) {
                    param.put("status", "1");
                } else {
                    param.put("status", "0");
                }
                page = 1;
                param.put("page", page);
                workProPresenter.getPro(param);
            }

            @Override
            public void clickOnSale(String value) {
                if (TextUtils.equals(value, "全部")) {
                    param.put("isExpectOut", "");
                } else if (TextUtils.equals(value, "已上架")) {
                    param.put("isExpectOut", true);
                } else {
                    param.put("isExpectOut", false);
                }
                page = 1;
                param.put("current", page);
                workProPresenter.getPro(param);
            }
        });
        rvData = filterData.getRvData();
        srlRefresh = filterData.getSrlRefresh();
    }


    @Override
    protected void initData() {
        param = WorkUtils.pageKey();
        param.put("ofKind", ofKind);
        dataList = new ArrayList<>();
        workProductAdapter = new WorkProductAdapter(R.layout.item_work_product, dataList);
        workProductAdapter.bindToRecyclerView(rvData);
        workProductAdapter.setEmptyView(R.layout.view_empty_content,rvData);
        workProPresenter.getPro(param);
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Bundle arguments = getArguments();
        if (arguments != null) {
            ofKind = arguments.getString("ofKind");
        }
    }

    @Override
    protected void initEvent() {
        srlRefresh.setOnRefreshListener(refreshLayout -> {
            page = 1;
            param.put("current", page);
            workProPresenter.getPro(param);
        });
        workProductAdapter.setOnLoadMoreListener(() -> {
            param.put("current", page);
            workProPresenter.getPro(param);
        }, rvData);
    }

    @Override
    protected int layoutId() {
        return R.layout.fg_work_pro;
    }


    @Override
    public void getPro(List<ProductBean.RecordsBean> data) {
        if (page == 1) {
            dataList.clear();
            dataList.addAll(data);
            workProductAdapter.notifyDataSetChanged();
            workProductAdapter.loadMoreComplete();
        } else {
            workProductAdapter.loadMoreComplete();
            dataList.addAll(data);
            workProductAdapter.notifyDataSetChanged();
        }
        if (data.size() == 0) {
            workProductAdapter.loadMoreEnd();
        } else {
            page++;
        }
    }
}
